<?php

/**
 * $Id: edit_language.php,v 1.2 2005/06/11 16:19:50 madbear Exp $
 * 
 * Copyright (c) 2004 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


$checkSession = true;
require_once('../includes/library.php');

if ($_SESSION['profilSession'] != 0) {
    header('Location: ../general/permissiondenied.php');
    exit;
}


//-----------------------
// start utility functions

// loads the translations for a particular language

function load_translations( $lang )
{
	global $base_dir;

	include_once($base_dir . './languages/lang_en.php');
	if ( file_exists( $base_dir . './languages/global_en.php') ) include_once( $base_dir . './languages/global_en.php' );
	
// then load language specific files if other than en (English)
	if ($lang != 'en') {
		if ( file_exists( $base_dir . './languages/lang_'. $lang . '.php' ) ) include_once($base_dir . './languages/lang_' . $lang . '.php');
		if ( file_exists( $base_dir . './languages/global_'.$lang.'.php') )   include_once($base_dir . './languages/global_' . $lang . '.php');
	}

	return $strings;
}

// saves a language out using form data

function save_translation( $lang, $addition = '', $remove = array() )
{
	global $base_dir;
	
	$translations = load_translations( $lang );

	$num = isset( $_GET[ 'count' ] ) ? $_GET['count']:0;

	for ( $i = 0; $i < $num; ++$i )
	{
		if ( isset( $_POST[ 'key'.$i ] ) )
		{
			$key = stripslashes( $_POST[ 'key'.$i ] );
			$value = stripslashes( $_POST[ 'trans'.$i ] );
			$translations[ $key ] = $value;
		}
	}

	if ( $file = fopen( $base_dir . './languages/global_' . $lang . '.php', 'w' ) )
	{
		$lookup = array();

		foreach( $remove as $id )
		{
			$lookup[ $id ] = true;
		}
		
		fwrite( $file, "<?php\n\n/* auto-generated by administration\edit_language.php */\n\n" );
		reset( $translations );
		$id = 0;
		foreach( $translations as $key => $value )
		{
			if ( !isset( $lookup[ $id ] ) )	// flagged for deletion?
			{
				fwrite( $file, '$strings[\''.addslashes($key).'\']=\''.addslashes($value).'\''.";\n" );
			}
			$id++;
		}

		if ( $addition != '' )
		{
			fwrite( $file, '$strings[\''.addslashes($addition).'\']=\''.addslashes($addition).'\''.";\n" );
		}
		
		fwrite( $file, "\n?>\n" );
		fclose( $file );

		echo count( $translations )-count( $lookup ). text( "translations_saved_ok" );
		if ( count( $lookup ) )
		{
			echo "<BR>".count( $lookup ) . text( "labels_deleted" );
		}
	}
}

// end utility functions
//-----------------------


$pagesize = 100;
$offset = isset( $_GET[ 'offset' ] ) ? $_GET[ 'offset' ] : 0;
$sellang = isset( $_GET[ 'language' ] ) ? $_GET[ 'language' ] : (isset( $_POST[ 'sellang' ] ) ? $_POST['sellang'] : $lang );

$breadcrumbs[]=buildLink('../administration/admin.php', text( 'administration' ) );
$breadcrumbs[]=text( 'edit_language' );

$pageSection = 'admin';
require_once('../themes/' . THEME . '/header.php');

if ( isset( $_GET[ 'action' ] ) )
{
	$topblock = new block();
	$topblock->headingForm( text( 'operation_result' ) );

	switch( $_GET[ 'action' ] )
	{
		case 'save':
			if (isset( $_GET[ 'language' ] ) )
			{
				save_translation( $_GET[ 'language' ] );
			}
			else echo text( 'Internal_Error' );
		break;
		case 'add':
			if ( isset( $_POST[ 'newlabel' ] ) )
			{
				save_translation( "en", $_POST[ 'newlabel' ] );
			}
			else echo text( 'Internal_Error' );
		break;
		case 'delete':
			if ( isset( $_GET[ 'id' ] ) )
			{
				$idlist = explode( '**', $_GET[ 'id' ] );
				save_translation($_GET[ 'language' ], '', $idlist );
			}
			else echo text( 'Internal_Error' );
		break;
		 
	}

	$topblock->headingForm_close();
	$topblock->block_close();
	echo "<BR>";
}


$block1 = new block();
$block1->headingForm( text('administration') );

// Language Selection Form

$block1->form = "langsel";
$block1->openForm("../administration/edit_language.php?offset=".$offset );

$block1->openContent();
$block1->contentTitle( text( 'language_intro' ) );

echo "<TR><TD ALIGN='center'>";

// build up language select list

asort( $langValue );
reset( $langValue );
$select = "";
foreach( $langValue as $key => $language )
{
	$select .= "<option value='".$key."'".(($sellang==$key)?" SELECTED":"").">".$language."</option>";
}

echo text( "Choose_Language" ) . ": <SELECT name='sellang' onChange='submit();'>".$select."</SELECT>";

echo "</TD></TR>";

$block1->closeContent();
$block1->closeForm();


// Label Add Form

$block1->form = "langadd";
$block1->openForm("../administration/edit_language.php?action=add&offset=".$offset );
$block1->openContent();
$block1->contentTitle( text( "add_new_label" ) );

echo "<TR><TD ALIGN='center'>";
echo text('Label').": <input name='newlabel' type='text'> ";
echo "<input type='submit' value='".text('add_label')."'>";

echo "</TD></TR>";

$block1->closeContent();
$block1->closeForm();



// Phrase Editing Form

$translations = load_translations( $sellang );

$block1->form = "langedit";
$block1->openForm("../administration/edit_language.php?action=save&language=".$sellang."&count=".count( $translations )."&offset=".$offset );

// build page links

$numpages = count( $translations ) / $pagesize;
$pagestr = "";
for ( $i = 0; $i < $numpages; $i++ )
{
	$pagestr .= ' ';
	if ( $offset / $pagesize != $i )
		$pagestr .= buildLink( '../administration/edit_language.php?offset='.$i*$pagesize.'&language='.$sellang, $i+1 );
	else $pagestr .= $i+1;
}

$block1->heading( text( "Phrases" ) . " ( " . $pagestr . " )" );

$block1->openPaletteIcon();
$block1->paletteIcon(1, "remove", text( "delete" ) );
$block1->closePaletteIcon();

// ok, now to list up all the phrases

$block1->openResults();
$block1->labels( $labels = array( 0=>text( 'Label' ), 1=>text( 'Translation' ) ), $published = "true", "true", $sortingOff = array( 0=>'0', 1=>'DESC' ) );

reset( $translations );
$id = 0;
$checkboxes = array();
foreach( $translations as $key => $value )
{
	if ( $id >= $offset && $id < $offset + $pagesize )
	{
		$block1->openRow( $id );
		$block1->checkboxRow( $id );
		$block1->cellRow( htmlspecialchars($key, ENT_QUOTES) );
		$block1->cellRow( "<input type='hidden' name='key".$id."' value=\"".htmlspecialchars($key, ENT_QUOTES)."\">"
			."<input size='80' name='trans".$id."' value=\"".htmlspecialchars($value, ENT_QUOTES)."\">"
			, 100 );
		$block1->closeRow();

		$checkboxes[] = $id;
	}

	$id++;
}

$block1->closeResults();

$block1->openContent();
echo "<TR><TD ALIGN='right'>";
echo text("click_to_save") . ": <input type='submit' value='".text('save_translation')."'>";
echo "</TD></TR>";
$block1->closeContent();

$block1->openPaletteScript();
$block1->paletteScript(1, "remove", "../administration/edit_language.php?language=".$sellang."&offset=".$offset."&action=delete", "false,true,true", text("delete"));
$block1->closePaletteScript($id, $checkboxes );

$block1->closeForm();


$block1->headingForm_close();
$block1->block_close();


require_once( '../themes/' . THEME . '/footer.php' );

?>
